# frozen_string_literal: true

module MigrationPal
  class StrideCalculator
    # See Yaning comment: https://wiki.doximity.com/articles/lhm-migrations
    MAX_TRANSACTION_SIZE_IN_MB = 5

    def initialize(table_size_in_megabytes, num_rows)
      # converted with online tool from sequel_pro table size GiB
      @table_size_in_megabytes = table_size_in_megabytes.to_f
      @num_rows = num_rows
    end

    def call
      (MAX_TRANSACTION_SIZE_IN_MB / row_size_in_mb).to_i
    end

    private

    def row_size_in_mb
      table_size_in_megabytes / num_rows
    end

    attr_reader :table_size_in_megabytes, :num_rows
  end
end
